package eu.chorevolution.vsb.manager;

import java.io.IOException;
import java.io.StringReader;
import java.io.StringWriter;
import java.io.Writer;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.apache.activemq.leveldb.replicated.ElectingLevelDBStore;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class TestDocument {
	private static Document serializedDoc = null;
	private NamedNodeMap attr = null;
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
		
		String serializedObject = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?><flowSegmentData xmlns=\"http://lbs.tomtom.com/services\" version=\"1.0.51-mascoma\"><frc>FRC2</frc><currentSpeed>16</currentSpeed><freeFlowSpeed>22</freeFlowSpeed><currentTravelTime>163</currentTravelTime><freeFlowTravelTime>118</freeFlowTravelTime><confidence>0.9</confidence><coordinates><coordinate><latitude>57.68803</latitude><longitude>11.922253</longitude></coordinate><coordinate><latitude>57.692772</latitude><longitude>11.914153</longitude></coordinate></coordinates></flowSegmentData>";
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder docBuilder = null;
		try {
			
			docBuilder = docFactory.newDocumentBuilder();
			InputSource is = new InputSource(new StringReader(serializedObject));
			serializedDoc = docBuilder.parse(is);
			prettyPrint(serializedDoc);
			Node firstNode = serializedDoc.getFirstChild();
			clean(firstNode);
			prettyPrint(serializedDoc);
			
			
			
			
		} catch (ParserConfigurationException | SAXException | IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}
	
	private static void clean(Node node){
		
		
		Element element = (Element) serializedDoc.getElementsByTagName(node.getNodeName()).item(0);
		updateNode(node,element);
		for(int i = 0; i < node.getChildNodes().getLength(); i++){
			
			Node childNode = node.getChildNodes().item(i);
			Element childElmt = (Element) serializedDoc.getElementsByTagName(childNode.getNodeName()).item(i);
			updateNode(childNode,childElmt);
			if(childNode.hasChildNodes()){
				
				clean(childNode);
			}
		}
	}
	
	private static void updateNode(Node node, Element elements){
		
		if(node.hasAttributes()){
			NamedNodeMap attr = node.getAttributes();
			String[] attribute = new String[attr.getLength()];
			for(int j = 0; j < attr.getLength(); j++){
				
				String attrName = attr.item(j).getNodeName();
				String attrValue = attr.item(j).getTextContent();
			    Node newnode = serializedDoc.createElement(attrName);
				newnode.setTextContent(attrValue);
				node.appendChild(newnode);
				elements.removeAttribute(attrName);
			}
			
			
		}
		
	}
	public static final void prettyPrint(Document xml) throws Exception {
		
			        Transformer tf = TransformerFactory.newInstance().newTransformer();
		
//			        tf.setOutputProperty(OutputKeys.ENCODING, "UTF-8");
//		
//			        tf.setOutputProperty(OutputKeys.INDENT, "yes");
		
			        Writer out = new StringWriter();
		
			        tf.transform(new DOMSource(xml), new StreamResult(out));
		
			        System.out.println(out.toString());
		
			    }

}
